#ifndef GLOBALS_H
#define GLOBALS_H

#include "wingmanRsc.h"
#include "trans.h"

#define TITLE_VERSION "1.5 beta"
#define INFO_VERSION "1.5b"
#define PROTOCOL_VERSION 0x01050200

#define INFO_URL  "about:" INFO_VERSION ".html"
#define APPTYPE 'TGwm'

extern DmOpenRef cacheDB;
extern DmOpenRef cacheInfoDB;
extern DmOpenRef offlineDB;
extern DmOpenRef offlineInfoDB;
extern DmOpenRef hotlistDB;
extern DmOpenRef storageDB;
extern DmOpenRef historyDB;

/* global variables */
extern ConID conID;           /* connection id for network subsystem */
extern VoidHand hPage;        /* handle to the current page */
extern WinHandle disp;        /* handle to the display window */
extern Word dispError;        /* error for window, needed to create window */
extern int currYPosOffset;    /* scrolling position for the page */
extern int currXPosOffset;    /* scrolling position for the page */
extern int lastLayoutYExtent; /* a trick to maybe get scroll limit working */
extern int penDownOrigPieceOff;    /* original pen down location */
extern SWord penDownOrigImageFlag; /* image save of pen down piece */
extern VoidHand hProxyServer;
extern char proxyServer[64];
extern int proxyPort;
extern char fallbackServer[64];
extern int fallbackPort;
extern int currRequestID;     /* data to allow dropping of old data */
extern int firstOpen;  /* redirects cancel back to splash on first instance */
extern ChunkHand curChunk;
extern VoidHand curURL;
extern Word curURLLength;
extern VoidHand transURL;
extern Word transURLLength;
extern int curHistory;
extern int tcurHistory;
extern Int curTop;

extern Boolean remap;
extern Int scrollSize;
extern Int histSize;

#define MAIN_DISPLAY_WIDTH 157
#define MAIN_DISPLAY_HEIGHT 146
#define SCROLL_THRESH 5
#define DEF_REMAP_VAL false
#define DEF_SCROLL_VAL 120
#define DEF_HIST_VAL 15
#define DEF_CACHE_VAL 102400
#define DEF_PROXY_IP "128.32.44.67"
#define DEF_PROXY_PORT 9114

extern ULong cacheSize;

extern DWord version;

void SetGlobals();


#endif /* GLOBALS_H */
