#ifndef PAGEDISPLAY_H
#define PAGEDISPLAY_H

/* defines for fonts */

#define BOLD         0x1
#define ITALIC       0x2
#define UNDERLINE    0x4
#define FONT_MASK    0x18
#define FONT_STD     0x0
#define FONT_BIG1    0x8
#define FONT_BIG2    0xf
#define FONT_BIG3    0x18
#define IMAGE        0x20
#define IMAGE_2BIT   0x1
#define IMAGE_HAS_SERV_SIZE 0x2
#define IMAGE_ISMAP  0x4
#define LINK         0x40
#define LINE         0x80
#define LINK_ALT     0x100

/* return current page dimensions in pixels */
void GetCurPageDims(SWord *widthp, SWord *heightp);

SWord WinDrawProxyString(VoidHand hText, int xScrollOffset, int yScrollOffset);
SWord WinDrawProxyStringGnomon(VoidHand hText, int xScrollOffset,
    int yScrollOffset, RectanglePtr r1, RectanglePtr r2);
SWord WinEraseProxyString(VoidHand hText, int xScrollOffset,
    int yScrollOffset);
void EraseMainWindow(void);
int PieceClicked(VoidHand proxyString, SWord xClick, SWord yClick,
    int xScrollOffset, int yScrollOffset, SWord *xcoordp, SWord *ycoordp);
int ClickImage(EventPtr pen, SWord *eventPiece, int xScrollOffset,
    int yScrollOffset);
int UpdateHiLiPiece(int event, int eventPieceOff, int xScrollOffset,
    int yScrollOffset);

void HiLiPiecesLink(int event, SWord *piece, char *linkURL, int xScrollOffset,
    int yScrollOffset);
void INTHiLiPiecesLink(int event, SWord *eventPiece, int direction,
    char *linkURL, int xScrollOffset, int yScrollOffset);

#endif /* PAGEDISPLAY_H */
