#ifndef TRANS_H
#define TRANS_H

typedef SDWord ConID;
typedef DWord RequestID;
typedef DWord ChunkID;
typedef DWord DataSize;
typedef DWord CompType;
typedef VoidHand ChunkHand;


#define TRANS_NO_COMP 1
#define TRANS_ERR_CON_CLOSED  1
#define MAX_CONNECTIONS 4
#define FIRST_CONNECTION 0

typedef struct {
  ConID conID;
  RequestID requestID;
  ChunkID chunkID;

  DataSize metaSize;
  DataSize dataSize;

  VoidHand metaHand;
  VoidHand dataHand;

  /* and now some stuff for database evilness... */
  ULong metaID;
  ULong dataID;
} Chunk;

typedef Chunk* ChunkPtr;

#define transNewChunk (firstUserEvent - 1)

typedef struct {
  enum events    eType;
  Boolean        penDown;
  SWord          screenX;
  SWord          screenY;
  union transData {
    struct transGeneric {
      Word data1;
      Word data2;
      Word data3;
      Word data4;
      Word data5;
      Word data6;
      Word data7;
      Word data8;
    } generic;
    struct {
      ChunkHand chunkHand;
    } newChunk;
  } data;
} transEvent;

typedef transEvent *transEventPtr; 

typedef void (*DataCallback)(DataSize *, DataSize *, void *);

Err StartTrans();
Err StopTrans();
Err SendChunk(ChunkPtr chunk);
void CheckNetwork();
ConID OpenConnection(char * host, unsigned short port, DmOpenRef db);
void CloseConnection(ConID conID, Boolean final);
Err DestroyChunk(ChunkHand ch);
void RegisterNotifyCallback(ConID conID, DataCallback cb, DataSize *total, 
		      DataSize * sofar, void * ptr);

#endif /* TRANS_H */


