#include <Pilot.h>
#include "globals.h"
#include "callback.h"
#include "send.h"
#include "urlform.h"
#include "history.h"
#include "editmenu.h"

Boolean URLFormHandleEvent (EventPtr e) {
  Boolean handled = false;
  FormPtr frm;
  CharPtr urlOutSet;
  CharPtr url = NULL;
  FieldPtr URLField;
  char c;
  int send;

  CALLBACK_PROLOGUE

  switch (e->eType) {
  case frmOpenEvent:
    frm = FrmGetActiveForm();

    if (curURL) {
      CharPtr RefreshChk = MemHandleLock(curURL);
      VoidHand hRefreshedURLFld = MemHandleNew(StrLen(RefreshChk) + 1);
      CharPtr RefreshedURLFld = MemHandleLock(hRefreshedURLFld);
      FormPtr pURLForm = FrmGetFormPtr(URLForm);
      FieldPtr pURL = FrmGetObjectPtr(pURLForm, FrmGetObjectIndex(pURLForm,
								  URLFormFld));
      StrCopy (RefreshedURLFld, RefreshChk);
      MemHandleUnlock(curURL);
      MemHandleUnlock(hRefreshedURLFld);
      FldFreeMemory(pURL);
      FldSetTextHandle(pURL, (Handle) hRefreshedURLFld);
    }

    FrmDrawForm(frm);
    FrmSetFocus(frm, FrmGetObjectIndex(frm, URLFormFld));

    handled = true;
    break;

  case menuEvent:
    MenuEraseStatus(NULL);
    if (EditMenuHandleEvent(e->data.menu.itemID, FrmGetActiveForm())) {
	handled = true;
    } else {
	switch(e->data.menu.itemID) {
	}
    }
    handled = true;
    break;

  case keyDownEvent:
    c = e->data.keyDown.chr;
    if (c == '\n' || c == '\r' || c == ' ' || c == '\t') {
	/* Don't allow obvious whitespace in the URL field.  Right now,
	   this is the only field in the form, so don't allow it in the
	   form at all.  - Ian */
	handled = true;
    }
    break;

  case ctlSelectEvent:
    switch(e->data.ctlEnter.controlID) {
      VoidHand tcurURL;
      ULong tcurURLLength;
      int newopen;
      
    case URLFormOK:
      frm = FrmGetActiveForm();
      newopen = 0;
      URLField = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, URLFormFld));
      /* get the text and the length */
      if(FldGetTextPtr(URLField)) {
	url = FldGetTextPtr(URLField);
	tcurURLLength = FldGetTextLength(URLField) + 1;
	/* create the handle and the copy point */
	tcurURL = MemHandleNew((ULong) tcurURLLength);
	if (tcurURL) {
	  urlOutSet = MemHandleLock(tcurURL);
	  /* copy it */
	  StrCopy (urlOutSet, url);
	} else {
	  /* if we needed space and didn't get it we have a problem */
	  ErrFatalDisplayIf(tcurURLLength, "Out of memory!");
	}
	MemHandleUnlock(tcurURL);	
	send = SendURL(&conID, tcurURL, true, true, false, true);
	if (!send) {
	  if (tcurURL) {
	    MemHandleFree(tcurURL);
	  }
	  newopen = 1;
	} 
      }
      if (firstOpen == 1) {
	if (!newopen) {
	  FrmGotoForm(MainForm); 
	  firstOpen = 0;
	} else {
	  FrmGotoForm(SplashForm); 
	}
      } else {
	FrmReturnToForm(0); 
      }
      break;
    case URLFormCan:
      if (firstOpen == 1) {
	FrmGotoForm(SplashForm);	
      } else {
	FrmReturnToForm(0); 
      }
      break;
    }
    handled = true;
    break;
  default:
    break;
  }

  CALLBACK_EPILOGUE

  return handled;
}
